SystemOrganization addCategory: #'MSK-FreeImage'!
SystemOrganization addCategory: #'MSK-FreeImage-Base'!
SystemOrganization addCategory: #'MSK-FreeImage-NativeBoost-Interface'!

Object subclass: #FreeImageLibrary
	instanceVariableNames: ''
	classVariableNames: 'InterfaceClass'
	poolDictionaries: ''
	category: 'MSK-FreeImage-Base'!

!FreeImageLibrary class methodsFor: 'accessing' stamp: 'MartenFeldtmann 4/5/2013 14:02'!
interfaceClass

	^InterfaceClass ! !

!FreeImageLibrary class methodsFor: 'accessing' stamp: 'MartenFeldtmann 4/5/2013 14:01'!
interfaceClass: value

	InterfaceClass := value! !

SharedPool subclass: #FreeImageConstants
	instanceVariableNames: ''
	classVariableNames: 'FIF_BMP FIF_GIF FIF_ICO FIF_JPEG FIF_PNG FIF_TIFF FIF_UNKNOWN'
	poolDictionaries: ''
	category: 'MSK-FreeImage-Base'!

Object subclass: #FIGeneralBitmap
	instanceVariableNames: 'address'
	classVariableNames: ''
	poolDictionaries: 'FreeImageConstants'
	category: 'MSK-FreeImage-Base'!

FIGeneralBitmap subclass: #FIBitmap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'FreeImageConstants'
	category: 'MSK-FreeImage-Base'!

!FIGeneralBitmap class methodsFor: 'instance creation' stamp: 'MartenFeldtmann 4/5/2013 16:40'!
address:  aNBExternalAddress

	^self new initialize
	  address: aNBExternalAddress ;
	  yourself! !

!FIGeneralBitmap class methodsFor: 'instance creation' stamp: 'MartenFeldtmann 4/5/2013 16:40'!
fromFile: aStringOrCfsPath
	"^<MSKFIGeneralBitmap | UndefinedObject>"
	
	| api fileFormat pathString |
	
	pathString := aStringOrCfsPath asString.
	api := FreeImageLibrary interfaceClass.
			
	fileFormat :=  api getFileType: pathString.
	(fileFormat = FIF_UNKNOWN) ifTrue:[ ^nil ].
	
	^self address: (api load: fileFormat filename: aStringOrCfsPath flags: 0)
	! !

!FIGeneralBitmap methodsFor: 'accessing' stamp: 'MartenFeldtmann 4/5/2013 16:39'!
address
	^ address! !

!FIGeneralBitmap methodsFor: 'accessing' stamp: 'MartenFeldtmann 4/5/2013 16:39'!
address: anObject
	address := anObject! !

!FIGeneralBitmap methodsFor: 'nativeboost-support' stamp: 'MartenFeldtmann 4/5/2013 16:42'!
asExternalFunctionParameter 

	^self address ! !

!FIGeneralBitmap methodsFor: 'service' stamp: 'MartenFeldtmann 4/5/2013 17:05'!
imageType

  ^FreeImageLibrary interfaceClass apiImageType: self asExternalFunctionParameter 


! !

!FIGeneralBitmap methodsFor: 'service' stamp: 'MartenFeldtmann 4/5/2013 16:53'!
save: fifConstant filename:aString flags: flags

	^FreeImageLibrary interfaceClass save: fifConstant bitmap: self filename: aString flags: flags! !

!FIGeneralBitmap methodsFor: 'service' stamp: 'MartenFeldtmann 4/5/2013 16:57'!
unload

	^FreeImageLibrary interfaceClass unload: self ! !

!FreeImageConstants class methodsFor: 'accessing' stamp: 'MartenFeldtmann 4/5/2013 16:54'!
fIF_BMP
	^ FIF_BMP! !

!FreeImageConstants class methodsFor: 'accessing' stamp: 'MartenFeldtmann 4/5/2013 16:54'!
fIF_BMP: anObject
	FIF_BMP := anObject! !

!FreeImageConstants class methodsFor: 'accessing' stamp: 'MartenFeldtmann 4/5/2013 16:54'!
fIF_GIF
	^ FIF_GIF! !

!FreeImageConstants class methodsFor: 'accessing' stamp: 'MartenFeldtmann 4/5/2013 16:54'!
fIF_GIF: anObject
	FIF_GIF := anObject! !

!FreeImageConstants class methodsFor: 'accessing' stamp: 'MartenFeldtmann 4/5/2013 16:19'!
fIF_JPEG
	^ FIF_JPEG! !

!FreeImageConstants class methodsFor: 'accessing' stamp: 'MartenFeldtmann 4/5/2013 16:19'!
fIF_JPEG: anObject
	FIF_JPEG := anObject! !

!FreeImageConstants class methodsFor: 'accessing' stamp: 'MartenFeldtmann 4/5/2013 16:54'!
fIF_PNG
	^ FIF_PNG! !

!FreeImageConstants class methodsFor: 'accessing' stamp: 'MartenFeldtmann 4/5/2013 16:54'!
fIF_PNG: anObject
	FIF_PNG := anObject! !

!FreeImageConstants class methodsFor: 'accessing' stamp: 'MartenFeldtmann 4/5/2013 16:54'!
fIF_TIFF
	^ FIF_TIFF! !

!FreeImageConstants class methodsFor: 'accessing' stamp: 'MartenFeldtmann 4/5/2013 16:54'!
fIF_TIFF: anObject
	FIF_TIFF := anObject! !

!FreeImageConstants class methodsFor: 'accessing' stamp: 'MartenFeldtmann 4/5/2013 16:55'!
fIF_UNKNOWN
	^ FIF_UNKNOWN! !

!FreeImageConstants class methodsFor: 'accessing' stamp: 'MartenFeldtmann 4/5/2013 16:55'!
fIF_UNKNOWN: anObject
	FIF_UNKNOWN := anObject! !

!FreeImageConstants class methodsFor: 'initialize-release' stamp: 'MartenFeldtmann 4/5/2013 15:14'!
initialize 
	"self initialize"
	
	self initializeGraphicsFormatConstants! !

!FreeImageConstants class methodsFor: 'initialize-release' stamp: 'MartenFeldtmann 4/5/2013 15:14'!
initializeGraphicsFormatConstants

	FIF_BMP := 0.
	FIF_GIF := 25.
	FIF_ICO := 1.
	FIF_JPEG := 2.
	FIF_PNG := 13.
	FIF_TIFF := 18.
	FIF_UNKNOWN := -1.! !

!FreeImageConstants methodsFor: 'initialize' stamp: 'MartenFeldtmann 4/5/2013 15:12'!
initialize

	self initializeGraphicsFormatConstants! !

!FreeImageConstants methodsFor: 'initialize' stamp: 'MartenFeldtmann 4/5/2013 15:12'!
initializeGraphicsFormatConstants! !

Object subclass: #FreeImageLibraryInterface
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'FreeImageConstants'
	category: 'MSK-FreeImage-NativeBoost-Interface'!

!FreeImageLibraryInterface class methodsFor: 'low-level-functions' stamp: 'MartenFeldtmann 4/5/2013 17:26'!
apiFIFSupportsReading: fifFormatValue
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self 
		nbCall: #( int8 FreeImage_FIFSupportsReading (int fifFormatValue ) ) 
		fnPrefix: self platformFunctionPrefix
		fnPostfix: (self platformFunctionPostfix: 4)
		options: #( + optStringOrNull optCoerceNilToNull ) 			
		module: self platformLibraryName  ! !

!FreeImageLibraryInterface class methodsFor: 'low-level-functions' stamp: 'MartenFeldtmann 4/5/2013 17:28'!
apiFIFSupportsWriting: fifFormatValue
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self 
		nbCall: #( int8 FreeImage_FIFSupportsWriting (int fifFormatValue ) ) 
		fnPrefix: self platformFunctionPrefix
		fnPostfix: (self platformFunctionPostfix: 4)
		options: #( + optStringOrNull optCoerceNilToNull ) 			
		module: self platformLibraryName  ! !

!FreeImageLibraryInterface class methodsFor: 'low-level-functions' stamp: 'MartenFeldtmann 4/5/2013 17:29'!
apiGetCopyrightMessage
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self 
		nbCall: #( NBExternalString FreeImage_GetCopyrightMessage () ) 
		fnPrefix: self platformFunctionPrefix
		fnPostfix: (self platformFunctionPostfix: 0)
		options: #( + optStringOrNull optCoerceNilToNull ) 				
		module: self platformLibraryName  ! !

!FreeImageLibraryInterface class methodsFor: 'low-level-functions' stamp: 'MartenFeldtmann 4/5/2013 15:28'!
apiGetFIFFromFilename: ptrToString
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self 
		nbCall: #( int FreeImage_GetFIFFromFilename (void* ptrToString ) ) 
		fnPrefix: self platformFunctionPrefix
		fnPostfix: (self platformFunctionPostfix: 4)
		options: #( + optStringOrNull optCoerceNilToNull ) 			
		module: self platformLibraryName  ! !

!FreeImageLibraryInterface class methodsFor: 'low-level-functions' stamp: 'MartenFeldtmann 4/5/2013 16:22'!
apiGetFileType: ptrToString size: int32Value
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self 
		nbCall: #( int FreeImage_GetFileType (NBExternalString  ptrToString, int int32Value ) ) 
		fnPrefix: self platformFunctionPrefix
		fnPostfix: (self platformFunctionPostfix: 8)
		options: #( + optStringOrNull optCoerceNilToNull ) 			
		module: self platformLibraryName  ! !

!FreeImageLibraryInterface class methodsFor: 'low-level-functions' stamp: 'MartenFeldtmann 4/5/2013 16:01'!
apiGetImageType: ptrToFIGeneralBitmap
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self 
		nbCall: #( void FreeImage_GetImageType (void * ptrToFIGeneralBitmap) ) 
		fnPrefix: self platformFunctionPrefix
		fnPostfix: (self platformFunctionPostfix: 4)
		options: #( + optStringOrNull optCoerceNilToNull ) 			
		module: self platformLibraryName  ! !

!FreeImageLibraryInterface class methodsFor: 'low-level-functions' stamp: 'MartenFeldtmann 4/5/2013 16:45'!
apiGetVersion
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self 
		nbCall: #( NBExternalString FreeImage_GetVersion () ) 
		fnPrefix: self platformFunctionPrefix
		fnPostfix: (self platformFunctionPostfix: 0)
		options: #( + optStringOrNull optCoerceNilToNull ) 				
		module: self platformLibraryName  ! !

!FreeImageLibraryInterface class methodsFor: 'low-level-functions' stamp: 'MartenFeldtmann 4/5/2013 17:04'!
apiImageType: bitmap
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self 
		nbCall: #( int FreeImage_GetImageType (NBExternalAddress bitmap) ) 
		fnPrefix: self platformFunctionPrefix
		fnPostfix: (self platformFunctionPostfix: 4 )
		options: #( + optStringOrNull optCoerceNilToNull ) 			
		module: self platformLibraryName  ! !

!FreeImageLibraryInterface class methodsFor: 'low-level-functions' stamp: 'MartenFeldtmann 4/5/2013 16:36'!
apiLoad: fifConstant filename: aString flags: flags
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self 
		nbCall: #( NBExternalAddress FreeImage_Load (int fifConstant, NBExternalString aString, int flags ) ) 
		fnPrefix: self platformFunctionPrefix
		fnPostfix: (self platformFunctionPostfix: 12 )
		options: #( + optStringOrNull optCoerceNilToNull ) 			
		module: self platformLibraryName  ! !

!FreeImageLibraryInterface class methodsFor: 'low-level-functions' stamp: 'MartenFeldtmann 4/5/2013 16:49'!
apiSave: fifConstant bitmap: bitmap filename: aString flags: flags
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self 
		nbCall: #( int FreeImage_Save (int fifConstant, NBExternalAddress bitmap, NBExternalString aString, int flags ) ) 
		fnPrefix: self platformFunctionPrefix
		fnPostfix: (self platformFunctionPostfix: 16 )
		options: #( + optStringOrNull optCoerceNilToNull ) 			
		module: self platformLibraryName  ! !

!FreeImageLibraryInterface class methodsFor: 'low-level-functions' stamp: 'MartenFeldtmann 4/5/2013 16:36'!
apiUnload: ptrToBitmap
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self 
		nbCall: #( void FreeImage_Unload (NBExternalAddress ptrToBitmap) ) 
		fnPrefix: self platformFunctionPrefix
		fnPostfix: (self platformFunctionPostfix: 4)
		options: #( + optStringOrNull optCoerceNilToNull ) 			
		module: self platformLibraryName  ! !

!FreeImageLibraryInterface class methodsFor: 'high-level-plugin-functions' stamp: 'MartenFeldtmann 4/5/2013 15:52'!
fifSupportsReading: fifFormatValue
	"^<Boolean> Returns true if the format is readable by this library
	"
	
	^(self apiFIFSupportsReading: fifFormatValue) = 1 ! !

!FreeImageLibraryInterface class methodsFor: 'high-level-plugin-functions' stamp: 'MartenFeldtmann 4/5/2013 17:28'!
fifSupportsWriting: fifFormatValue
	"^<Boolean> Returns true if the format is readable by this library
	"
	
	^(self apiFIFSupportsWriting: fifFormatValue) = 1 ! !

!FreeImageLibraryInterface class methodsFor: 'high-level-general-functions' stamp: 'MartenFeldtmann 4/5/2013 17:30'!
getCopyrightMessage
	"self getCopyrightMessage"
	^self apiGetCopyrightMessage! !

!FreeImageLibraryInterface class methodsFor: 'high-level-plugin-functions' stamp: 'MartenFeldtmann 4/5/2013 15:35'!
getFIFFromFilename: ptrToString
	"^<Integer> Returns the constant value of the graphcs format of the file
	
	FreeImageLibraryInterface getFIFFromFilename: 'D:\Pharo2.0-portable\Pharo2.0-portable.app\test-data-freeimage\Asch_A.jpg'
	
	"
	
	^self apiGetFIFFromFilename: ptrToString! !

!FreeImageLibraryInterface class methodsFor: 'high-level-Filetype' stamp: 'MartenFeldtmann 4/5/2013 15:33'!
getFileType: pathStringToFile

	"
	 	FreeImageLibraryInterface getFileType: 'D:\Pharo2.0-portable\Pharo2.0-portable.app\test-data-freeimage\Asch_A.jpg'
	"
	^self getFileType: pathStringToFile size: 0! !

!FreeImageLibraryInterface class methodsFor: 'high-level-Filetype' stamp: 'MartenFeldtmann 4/5/2013 16:23'!
getFileType: pathStringToFile size: sizeInteger

	^self apiGetFileType: pathStringToFile size: sizeInteger! !

!FreeImageLibraryInterface class methodsFor: 'high-level-general-functions' stamp: 'MartenFeldtmann 4/5/2013 16:45'!
getVersion
	"self getVersion"
	^self apiGetVersion! !

!FreeImageLibraryInterface class methodsFor: 'high-level-bitmap-information' stamp: 'MartenFeldtmann 4/5/2013 17:06'!
imageType: bitmap

	^self apiImageType: bitmap asExternalFunctionParameter ! !

!FreeImageLibraryInterface class methodsFor: 'class initialization' stamp: 'MartenFeldtmann 4/5/2013 14:03'!
initialize 
	
	Smalltalk addToStartUpList: self.
	self initializeFreeImageSubsystem: true.! !

!FreeImageLibraryInterface class methodsFor: 'class initialization' stamp: 'MartenFeldtmann 4/5/2013 14:03'!
initializeFreeImageSubsystem

  self initializeFreeImageSubsystem: true! !

!FreeImageLibraryInterface class methodsFor: 'class initialization' stamp: 'MartenFeldtmann 4/6/2013 13:06'!
initializeFreeImageSubsystem: forceFlag

	Transcript
		cr;
		show: 'FreeImage Startup'.
		
	FreeImageLibrary interfaceClass: self.
	self removeNativeCode.
	
	[
		Transcript
			cr;
			show: 'FreeImage Library Version found: ' , self getVersion 
	]
	on: Error
	do: [ :sig | 
		Transcript
			cr;
			show: 'No FreeImage Library found' 
	]! !

!FreeImageLibraryInterface class methodsFor: 'configuration-helpers' stamp: 'MartenFeldtmann 4/5/2013 14:18'!
libraryAvailable
	"^<Boolean> Returns true if the native library is available - otherwise false.
	
		self libraryAvailable
	"
	| functionName libraryName |
	
	functionName := self platformVersionFunctionName.
	libraryName := self platformLibraryName.

	^(NativeBoost loadSymbol: functionName fromModule: libraryName) notNil
	
	
	! !

!FreeImageLibraryInterface class methodsFor: 'high-level-bitmap-management' stamp: 'MartenFeldtmann 4/5/2013 16:47'!
load: fifConstant filename: aString flags: flags
	"comment stating purpose of message"

	^FIBitmap  address: (self apiLoad: fifConstant filename: aString flags: flags)! !

!FreeImageLibraryInterface class methodsFor: 'loading-saving' stamp: 'MartenFeldtmann 4/5/2013 17:13'!
loadFromFile: pathString
	"^<MSKFIGeneralBitmap | nil>"
	
	| fileFormat |

	fileFormat :=  self apiGetFileType: pathString size: 0.
	(fileFormat == FIF_UNKNOWN) ifTrue:[ ^nil ].
	
	^(self fifSupportsReading: fileFormat)
		ifTrue:[		self load: fileFormat filename: pathString flags: 0 ]
		ifFalse:[		self halt ].! !

!FreeImageLibraryInterface class methodsFor: 'nativeboost-helpers' stamp: 'MartenFeldtmann 4/6/2013 13:05'!
nbCall: fnSpec fnPrefix: fnPrefixString fnPostfix: fnPostfixString options: callOptions module: moduleName

	| sender realSpec |
	
	sender := thisContext sender.
	realSpec := self nbSetUp: fnSpec fnPrefix: fnPrefixString fnPostfix: fnPostfixString.
	
	^ NBFFICallout  
		handleFailureIn: sender
		nativeCode: [ :gen |
			gen
				sender: sender;
				callType: self platformCallingConventions;
				parseOptions: callOptions;
				generateCall: realSpec module: moduleName ]! !

!FreeImageLibraryInterface class methodsFor: 'nativeboost-helpers' stamp: 'MartenFeldtmann 4/5/2013 15:00'!
nbSetUp: fnSpec fnPrefix: fnPrefixString fnPostfix: fnPostfixString
	"If required, add the version suffix to the function name."

	| index function |
		
	index := fnSpec size - 1.
	function := fnPrefixString,(fnSpec at: index), fnPostfixString.
		
	^ fnSpec copy
		at: index put: function ;
		yourself! !

!FreeImageLibraryInterface class methodsFor: 'nativeboost-helpers' stamp: 'MartenFeldtmann 4/6/2013 13:04'!
platformCallingConventions

	Smalltalk os isWin32 
		ifTrue: [ ^ #stdcall ].
		
	^#cdecl! !

!FreeImageLibraryInterface class methodsFor: 'nativeboost-helpers' stamp: 'MartenFeldtmann 4/5/2013 15:03'!
platformFunctionPostfix: bytes

	Smalltalk os isWin32 
		ifTrue: [ ^ '@', bytes asString ].
		
	Smalltalk os isMacOSX
		ifTrue: [ ^ '' ].
		
	^ ''! !

!FreeImageLibraryInterface class methodsFor: 'nativeboost-helpers' stamp: 'MartenFeldtmann 4/5/2013 14:58'!
platformFunctionPrefix

	Smalltalk os isWin32 
		ifTrue: [ ^ '_' ].
		
	Smalltalk os isMacOSX
		ifTrue: [ ^ '' ].
		
	^ ''! !

!FreeImageLibraryInterface class methodsFor: 'platform-specifics' stamp: 'MartenFeldtmann 4/5/2013 14:11'!
platformLibraryName

	Smalltalk os isWin32 
		ifTrue: [ ^ 'FreeImage.dll' ].
		
	Smalltalk os isMacOSX
		ifTrue: [ ^ '' ].
		
	^ ''! !

!FreeImageLibraryInterface class methodsFor: 'platform-specifics' stamp: 'MartenFeldtmann 4/5/2013 14:18'!
platformVersionFunctionName

	Smalltalk os isWin32 
		ifTrue: [ ^ '_FreeImage_GetVersion@0' ].
		
	Smalltalk os isMacOSX
		ifTrue: [ ^ '' ].
		
	^ ''! !

!FreeImageLibraryInterface class methodsFor: 'nativeboost-helpers' stamp: 'MartenFeldtmann 4/5/2013 14:40'!
removeNativeCode
	"self removeNativeCode"
	
	| compiledMethodsWithSpecificPragma |
	compiledMethodsWithSpecificPragma := self methods
		select: [ :eachCompiledMethod | (eachCompiledMethod pragmaAt: #primitive:module:) notNil ].
	compiledMethodsWithSpecificPragma
		do: [ :eachCompiledMethod | NBNativeCodeGen removeNativeCodeFrom: eachCompiledMethod ].
	Transcript
		cr;
		show: 'FreeImage Native Code removed from Methods'! !

!FreeImageLibraryInterface class methodsFor: 'high-level-bitmap-management' stamp: 'MartenFeldtmann 4/5/2013 16:52'!
save: fifConstant bitmap: bitmap filename: aString flags: flags
	"^<Boolean> Stores the content of bitmap into a file in a specific graphic format"

	^(self apiSave: fifConstant bitmap: bitmap asExternalFunctionParameter  filename: aString  flags: flags) = 1! !

!FreeImageLibraryInterface class methodsFor: 'class initialization' stamp: 'MartenFeldtmann 4/5/2013 14:04'!
startUp: resuming
	"This method should be called whenever the system starts working"
	
	self initializeFreeImageSubsystem: resuming! !

!FreeImageLibraryInterface class methodsFor: 'class initialization' stamp: 'MartenFeldtmann 4/6/2013 13:06'!
unload 

	Transcript
		cr;
		show: 'FreeImage Shutdown'.

	FreeImageLibrary interfaceClass: nil.
	Smalltalk removeFromStartUpList: self
			! !

!FreeImageLibraryInterface class methodsFor: 'high-level-bitmap-management' stamp: 'MartenFeldtmann 4/5/2013 16:43'!
unload: fiGeneralBitmap
	"comment stating purpose of message"

	self apiUnload:  fiGeneralBitmap asExternalFunctionParameter ! !
FreeImageConstants initialize!
FreeImageLibraryInterface initialize!
